org.thewonderlemming.c4plantuml.mojo

## Class ReportingMojo

- java.lang.Object
- - org.apache.maven.plugin.AbstractMojo
  - - org.thewonderlemming.c4plantuml.mojo.AbstractParentMojo
    - - org.thewonderlemming.c4plantuml.mojo.ReportingMojo

- All Implemented Interfaces:
    org.apache.maven.plugin.ContextEnabled, org.apache.maven.plugin.Mojo

      @Mojo(name="report",
            defaultPhase=PROCESS_CLASSES)
      public class ReportingMojo
      extends AbstractParentMojo

  A MOJO that parses the C4 PlantUML files that are contained in the output directory and generates a GraphML file with the gathered information.
  Author:
    thewonderlemming

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static String` | `FAIL_ON_PARSE_ERRORS_DEFAULT_VALUE` Default value for the `failOnParseErrors` property.
    `static String` | `FORMAT_OUTPUT_DEFAULT_VALUE` Default value for the `formatOutput` property.
    `static String` | `OUTPUT_FILENAME_DEFAULT_VALUE` Default value for the generated GraphML filename.

    - ### Fields inherited from class org.thewonderlemming.c4plantuml.mojo.AbstractParentMojo

      `DEFAULT_SOURCE_FILE_EXTENSION`

    - ### Fields inherited from interface org.apache.maven.plugin.Mojo

      `ROLE`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `ReportingMojo()`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected void` | `doExecute()` Gathers information from the C4 PlantUML files and outputs it as a GraphML file.

    - ### Methods inherited from class org.thewonderlemming.c4plantuml.mojo.AbstractParentMojo

      `execute, getCurrentCharset, getOutputDirectory, getProject, getSourceFileExtension, processOutputDirectoryFiles, validateSourceFileExtension`

    - ### Methods inherited from class org.apache.maven.plugin.AbstractMojo

      `getLog, getPluginContext, setLog, setPluginContext`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### FAIL_ON_PARSE_ERRORS_DEFAULT_VALUE

          public static final String FAIL_ON_PARSE_ERRORS_DEFAULT_VALUE

      Default value for the `failOnParseErrors` property.
      See Also:
        Constant Field Values

    - #### FORMAT_OUTPUT_DEFAULT_VALUE

          public static final String FORMAT_OUTPUT_DEFAULT_VALUE

      Default value for the `formatOutput` property.
      See Also:
        Constant Field Values

    - #### OUTPUT_FILENAME_DEFAULT_VALUE

          public static final String OUTPUT_FILENAME_DEFAULT_VALUE

      Default value for the generated GraphML filename.

      It is linked to the `outputFilename` property. If the given `outputFilename` is not an absolute path, then it will be created in the `outputDirectory`.

      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### ReportingMojo

          public ReportingMojo()

  - ### Method Detail

    - #### doExecute

          protected void doExecute()
                            throws org.apache.maven.plugin.MojoExecutionException,
                                   org.apache.maven.plugin.MojoFailureException

      Gathers information from the C4 PlantUML files and outputs it as a GraphML file.

      An abstract method to hold the children classes execution logic.

      Specified by:
        `doExecute` in class `AbstractParentMojo`
      Throws:
        `org.apache.maven.plugin.MojoExecutionException` - if there is an issue with the build that makes it impossible to continue.
        `org.apache.maven.plugin.MojoFailureException` - if there is any other kind of failures.

Copyright © 2020. All rights reserved.